









		SILENT BOB
"Silent Bob", actually, it can be drawn an analogy with three programs, which
leaded to its creation, ctags, cscope, ctree( first I'll describe them, and
their problems, and then - their differences from "Bob").

Description of some programs  ( on which motives SilentBob was written)

Let's take, for example, such well-known program as ctags, probably you've
used it and you know it's main point of work. It simply creates special file,
which stores information about some source files. Usually it's OS kernels and
other big programs, like sendmail or apache. This file contains:
1. "Addresses" of all functions, structures, macroses, etc. "Address" means
file name + string number (or regular expression, using which an appropriate
string can be found). That file, for example, in Vim, can be used to evaluate
":tag <name>" to make a quick switch. Also ctags allows to extract "goodies"
from files - simply to find out its contents.

csope - very useful program, it doesn't create file, described above, but can
do search and has some additional features:
1. Interface for "comfortable" search.
2. It can trace which functions called and what does they call (one layer
"lower")
3. It also can trace who calls certain functions  (one layer "upper")
And some other feature, which I have never used...

And at last - ctree. Theoreticaly, it can show all above described information
several layers "lower". Practically I couldn't turn it on.

Problems of existing software

ctags problems:
For "tags" file creation regular expressions are used, which allows to add
other languages, but places a substantial limits:
1. Quality of received information is quite low.
2. Information, which we receive, in "interactive" mode is not full enough.
3. Support for C++ is present, but not quite good.

cscope problems:
Actually, all ctags problems, plus:
1. Base, which actually doesn't needed anybody, but "weights" 150 Mbytes (for
Linux 2.6.14 for example)
2. Quality of "interactivity" is not good enough
3. Support for C++ is absent. This is not good, because problems, which this
kind of software is called to solve, lies down to different libraries,
including Qt3/GTK.

In SilentBob this problems are absent. Program uses preprocessor (written by
me) either than regular expressions.

Main ideas of SilentBob

Preprocessor, which is described above, is called "THE_TT" and placed in
appropriate file...
Actually it's quite simple: it removes all "extras" from C/C++ source. It
removes/minimizes all variants of C code notations, removes all extra space
symbols and comments, adds additional spaces where it's necessary (for
example, before brackets). THE_TT allows to take some part of code and
exactly (about 99%) tell you what is it, using minimum of checks.
All it works quite fast (for example, 1.6 GHz processor, 256 Mb of RAM - works
excellent), which allows to do some interesting things. As far as I know,
such kind of code usually is written only to compilers and isn't used for
other things, what, as for my view, isn't good enough.

Next SilentBob's level - "t_op", "what_is_this" and alike functions. First of
them simply allows to enumerate all "operators" of source code, second -
checks, what kind of operator do we met. Actually, "what_is_this" isn't
quite enough for all, so some additional functions exists... Now, THE_TT and
t_op are two separate parts of program. In future I plan to unite them...

It took from me for about one month to develop current version (1.0-rc1) and
two months for testing, finding out bugs, etc.

LYRICS
("life story", "blog" )

SilentBob was written one dark night, when one Siberian fellow tried to
understand how sys_poll system call works. After some time of digging the
sources and several tanks of drinked beer, this fellow understood, that
abilities of Gvim only isn't quite enough. Some tricks was made - they helped
a little, but this wasn't the solution.
Then, some other popular programs was used. After several tries fellow
understood, that he received the access to function he needs. But only one
function. If you take into account, that such calls, let's say, not only one
in program - you can imaging fellows indignation.

